// file: hmm_dd_constants.h
//
// this file defines constants used in hmm_dd
//

// Make sure this file is only included once
//
#ifndef __ISIP_HMM_CONSTANTS
#define __ISIP_HMM_CONSTANTS

// important constants
//
#define ISIP_PROGRAM_NAME "hmm"

// define default values related to the model architecture
//
#define ISIP_DEFAULT_S (int_4)2
#define ISIP_DEFAULT_K (int_4)2
#define ISIP_DEFAULT_P (int_4)10
#define ISIP_DEFAULT_L (int_4)100

// define algorithm flags
//
#define ISIP_ALG_VITERBI (int_4)0
#define ISIP_ALG_BAUMWELCH (int_4)1
#define ISIP_DEFAULT_ALG ISIP_ALG_VITERBI

// define mode flags
//
#define ISIP_MODE_TRAIN (int_4)0
#define ISIP_MODE_TEST (int_4)1
#define ISIP_MODE_GENERATE (int_4)2
#define ISIP_MODE_UPDATE (int_4)3
#define ISIP_DEFAULT_MODE ISIP_MODE_TEST

// define the default debug mode
//
#define ISIP_DEFAULT_DBG ISIP_DEBUG_NONE

// define command line identifiers
//
#define ISIP_OPT_S "-S"
#define ISIP_OPT_K "-K"
#define ISIP_OPT_P "-P"
#define ISIP_OPT_L "-L"
#define ISIP_OPT_DBG "-debug"

#define ISIP_OPT_ALG_1 "-viterbi"
#define ISIP_OPT_ALG_2 "-baumwelch"

#define ISIP_OPT_MODE_1 "-train"
#define ISIP_OPT_MODE_2 "-test"
#define ISIP_OPT_MODE_3 "-generate"
#define ISIP_OPT_MODE_4 "-update"

#define ISIP_OPT_HELP "-help"

// define constants
//
#define ISIP_MAX_LINE_SIZE 1024
#define ISIP_MIN_PROB 1e-04

//
// end of file
#endif
