// file: hmm_cstr.cc
//
// constructors and destructors
//

// system include files
//
#include <stdlib.h>

// isip include files
//
#include "../include/hmm.h"

#include "../include/integral_constants.h"

//-----------------------------------------------------------------------------
// method: constructor
//
// arguments: none
//
// return: none
//
// this is the default constructor for the hmm class
//
//-----------------------------------------------------------------------------
Hmm::Hmm() {

  // clear space for input sequences
  //
  S = (int_4)0;
  K = (int_4)0;

  // clear space for the hmm
  //
  y = (char_1*)NULL;
  a = (float_4**)NULL;
  b = (float_4**)NULL;
  pi = (float_4*)NULL;

  // clear space for the update parameters
  //
  a_new = (float_4**)NULL;
  b_new = (float_4**)NULL;
  pi_new = (float_4*)NULL;

  // seed the random number generator
  //
  srand48(ISIP_RANDSEED);

  // exit gracefully
  //
}

//-----------------------------------------------------------------------------
// method: destructor
//
// arguments: none
//
// return: none
//
// this is the default destructor for the hmm class
//
//-----------------------------------------------------------------------------
Hmm::~Hmm() {

  // cleanup
  //
  cleanup_cc();

  // cleanup counters
  //
  cleanup_counters_cc();

  // exit gracefully
  //
}
